%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define jafver  1.1
%define jar_name activation

Summary:        Glassfish - JavaBeans Activation Framework
Name:           glassfish-jaf
Version:        1.1.0
Release:        0jpp.ep1.9%{?dist}
Epoch:          0
License:        CDDL
Group:          Development/Java
URL:            http://glassfish.dev.java.net/

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:      noarch
Source0:        %{name}-%{version}.tar.gz
#cvs -d :pserver:guest@cvs.dev.java.net:/cvs checkout glassfish/activation
Source1:	%{name}-%{version}-LICENCE.tar.gz
#cvs -d :pserver:guest@cvs.dev.java.net:/cvs checkout glassfish/bootstrap ... this tar is a tar of the legal folder under glassfish/bootstrap
Source2:	activation-1.1.pom
Source3:	%{name}-component-info.xml
Patch0:		%{name}-%{version}-ant-hack.patch

BuildRequires:  ant >= 0:1.6.5
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.4.2

Provides:       jaf = 0:%{jafver}
Provides:       jaf_api = 0:%{jafver}
Provides:       jaf_1_1_api
Provides:	activation

%define repodir %{_javadir}/repository.jboss.com/sun-jaf/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%description
JavaBeans Activation Framework 

%package	javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm
Provides:       jaf-javadoc = 0:%{jafver}

%description 	javadoc
%{summary}.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -n %{name} 

%patch -p1

tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE3}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE3}

#Unpack the LICENCE tarball
tar -xvzf %{SOURCE1}

%build
if [ -z "$JAVA_HOME" ]; then export JAVA_HOME=/usr/lib/jvm/java; fi
ant release

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 0644 build/release/%{jar_name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap javax.activation activation %{version} JPP %{name}

pushd $RPM_BUILD_ROOT%{_javadir}
ln -sf %{name}-%{version}.jar %{name}.jar
popd

#(cd $RPM_BUILD_ROOT%{_javadir}
#ln -s %{name}-%{version}.jar jaf-%{jafver}.jar
#ln -s %{name}-%{version}.jar jaf_api.jar
#ln -s %{name}-%{version}.jar jaf_1_1_api.jar
#ln -s %{name}-%{version}.jar jaf.jar
#)

touch $RPM_BUILD_ROOT%{_javadir}/activation.jar
touch $RPM_BUILD_ROOT%{_javadir}/jaf.jar
touch $RPM_BUILD_ROOT%{_javadir}/jaf_api.jar
touch $RPM_BUILD_ROOT%{_javadir}/jaf_1_1_api.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/release/docs/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p build/META-INF/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/%{jar_name}.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap
/usr/sbin/update-alternatives --install %{_javadir}/jaf.jar jaf %{_javadir}/%{name}.jar 10100
/usr/sbin/update-alternatives --install %{_javadir}/activation.jar activation %{_javadir}/%{name}.jar 10100
/usr/sbin/update-alternatives --install %{_javadir}/jaf_api.jar jaf_api %{_javadir}/%{name}.jar 10100
/usr/sbin/update-alternatives --install %{_javadir}/jaf_1_1_api.jar jaf_1_1_api %{_javadir}/%{name}.jar 10100

%preun
if [ "$1" = "0" ]; then
    /usr/sbin/update-alternatives --remove jaf %{_javadir}/%{name}.jar
    /usr/sbin/update-alternatives --remove jaf_api %{_javadir}/%{name}.jar
    /usr/sbin/update-alternatives --remove activation %{_javadir}/%{name}.jar
    /usr/sbin/update-alternatives --remove jaf_1_1_api %{_javadir}/%{name}.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}
#%{_javadir}/jaf-%{jafver}.jar
%ghost %{_javadir}/jaf.jar
%ghost %{_javadir}/activation.jar
%ghost %{_javadir}/jaf_api.jar
%ghost %{_javadir}/jaf_1_1_api.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.9
- Revert to sun-jaf name due to "buildmagic" 

* Fri Nov 23 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.8
- Build with debug info

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.7
- Parametrize component-info contents
- Install real JAR into repolibdir

* Thu Nov 22 2007 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.6
- Fix installed name of component-info.xml

* Thu Nov 22 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.5
- Adding component-info.xml
- Changed the repodir to glassfish/jaf 
- Insert alternatives for activation

* Tue Nov 20 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.4
- Adding in the pom stuff 

* Thu Nov 15 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.3
- Rebuild with 1.5 

* Thu Nov 15 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.2
- Add jaf jaf_api jaf_1_1_api Provides and alternatives

* Tue Nov 13 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.1
- First release.
